package com.gxwebsoft.common.system.controller;

import com.gxwebsoft.common.core.web.BaseController;
import com.gxwebsoft.common.system.entity.User;
import com.gxwebsoft.common.system.service.PlugService;
import com.gxwebsoft.common.system.entity.Plug;
import com.gxwebsoft.common.system.param.PlugParam;
import com.gxwebsoft.common.core.web.ApiResult;
import com.gxwebsoft.common.core.web.PageResult;
import com.gxwebsoft.common.core.web.BatchParam;
import com.gxwebsoft.common.core.annotation.OperationLog;
import io.swagger.v3.oas.annotations.tags.Tag;
import io.swagger.v3.oas.annotations.Operation;
import org.springframework.security.access.prepost.PreAuthorize;
import org.springframework.web.bind.annotation.*;

import javax.annotation.Resource;
import java.util.List;

/**
 * 插件扩展控制器
 *
 * @author 科技小王子
 * @since 2023-10-12 09:53:07
 */
@Tag(name = "插件")
@RestController
@RequestMapping("/api/system/plug")
public class PlugController extends BaseController {
    @Resource
    private PlugService plugService;

    @Operation(summary = "分页查询插件扩展")
    @GetMapping("/page")
    public ApiResult<PageResult<Plug>> page(PlugParam param) {
        // 使用关联查询
        return success(plugService.pageRel(param));
    }

    @Operation(summary = "查询全部插件扩展")
    @GetMapping()
    public ApiResult<List<Plug>> list(PlugParam param) {
        // 使用关联查询
        return success(plugService.listRel(param));
    }

    @Operation(summary = "根据id查询插件扩展")
    @GetMapping("/{id}")
    public ApiResult<Plug> get(@PathVariable("id") Integer id) {
        // 使用关联查询
        return success(plugService.getByIdRel(id));
    }

    @PreAuthorize("hasAuthority('sys:plug:save')")
    @OperationLog
    @Operation(summary = "添加插件扩展")
    @PostMapping()
    public ApiResult<?> save(@RequestBody Plug plug) {
        // 记录当前登录用户id
        User loginUser = getLoginUser();
        if (loginUser != null) {
          plug.setUserId(loginUser.getUserId());
        }
        if (plugService.save(plug)) {
            return success("添加成功");
        }
        return fail("添加失败");
    }

    @PreAuthorize("hasAuthority('sys:plug:update')")
    @OperationLog
    @Operation(summary = "修改插件扩展")
    @PutMapping()
    public ApiResult<?> update(@RequestBody Plug plug) {
        if (plugService.updateById(plug)) {
            return success("修改成功");
        }
        return fail("修改失败");
    }

    @PreAuthorize("hasAuthority('sys:plug:remove')")
    @OperationLog
    @Operation(summary = "删除插件扩展")
    @DeleteMapping("/{id}")
    public ApiResult<?> remove(@PathVariable("id") Integer id) {
        if (plugService.removeById(id)) {
            return success("删除成功");
        }
        return fail("删除失败");
    }

    @PreAuthorize("hasAuthority('sys:plug:save')")
    @OperationLog
    @Operation(summary = "批量添加插件扩展")
    @PostMapping("/batch")
    public ApiResult<?> saveBatch(@RequestBody List<Plug> list) {
        if (plugService.saveBatch(list)) {
            return success("添加成功");
        }
        return fail("添加失败");
    }

    @PreAuthorize("hasAuthority('sys:plug:update')")
    @OperationLog
    @Operation(summary = "批量修改插件扩展")
    @PutMapping("/batch")
    public ApiResult<?> removeBatch(@RequestBody BatchParam<Plug> batchParam) {
        if (batchParam.update(plugService, "plug_id")) {
            return success("修改成功");
        }
        return fail("修改失败");
    }

    @PreAuthorize("hasAuthority('sys:plug:remove')")
    @OperationLog
    @Operation(summary = "批量删除插件扩展")
    @DeleteMapping("/batch")
    public ApiResult<?> removeBatch(@RequestBody List<Integer> ids) {
        if (plugService.removeByIds(ids)) {
            return success("删除成功");
        }
        return fail("删除失败");
    }

}
